"use strict";
exports.__esModule = true;
exports.createLoader = exports.createUseLoader = void 0;
var tslib_1 = require("tslib");
var aggregateToQuery_1 = require("./aggregateToQuery");
var RTKLoader_1 = require("./RTKLoader");
var createUseLoader = function (createUseLoaderArgs) {
    var useLoader = function () {
        var _a, _b;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var createdQueries = createUseLoaderArgs.queries.apply(createUseLoaderArgs, args);
        var deferredQueries = (_b = (_a = createUseLoaderArgs.deferredQueries) === null || _a === void 0 ? void 0 : _a.call.apply(_a, (0, tslib_1.__spreadArray)([createUseLoaderArgs], args, false))) !== null && _b !== void 0 ? _b : [];
        var aggregatedQuery = (0, aggregateToQuery_1.aggregateToQuery)(createdQueries);
        if (aggregatedQuery.isSuccess) {
            var data = createUseLoaderArgs.transform
                ? createUseLoaderArgs.transform(createdQueries, deferredQueries)
                : createdQueries;
            return (0, tslib_1.__assign)((0, tslib_1.__assign)({}, aggregatedQuery), { data: data, currentData: data, originalArgs: args });
        }
        return aggregatedQuery;
    };
    return useLoader;
};
exports.createUseLoader = createUseLoader;
var createLoader = function (createLoaderArgs) {
    var _a, _b;
    var useLoader = (0, exports.createUseLoader)({
        queries: (_a = createLoaderArgs.queries) !== null && _a !== void 0 ? _a : (function () { return []; }),
        transform: createLoaderArgs.transform,
        deferredQueries: createLoaderArgs.deferredQueries
    });
    var loader = {
        useLoader: useLoader,
        onLoading: createLoaderArgs.onLoading,
        onError: createLoaderArgs.onError,
        onFetching: createLoaderArgs.onFetching,
        whileFetching: createLoaderArgs.whileFetching,
        queriesArg: createLoaderArgs.queriesArg,
        LoaderComponent: (_b = createLoaderArgs.loaderComponent) !== null && _b !== void 0 ? _b : RTKLoader_1.RTKLoader,
        extend: function (_a) {
            var queries = _a.queries, deferredQueries = _a.deferredQueries, transform = _a.transform, loaderArgs = (0, tslib_1.__rest)(_a, ["queries", "deferredQueries", "transform"]);
            var extendedLoader = (0, tslib_1.__assign)((0, tslib_1.__assign)({}, this), loaderArgs);
            if (queries) {
                var newUseLoader = (0, exports.createUseLoader)({
                    queries: queries,
                    transform: transform,
                    deferredQueries: deferredQueries
                });
                extendedLoader.useLoader = newUseLoader;
            }
            return extendedLoader;
        }
    };
    return loader;
};
exports.createLoader = createLoader;
//# sourceMappingURL=createLoader.js.map